package com.diagbot.repository;

import com.diagbot.entity.node.EntityInfo;
import com.diagbot.entity.node.Lis;
import org.springframework.data.neo4j.annotation.Query;
import org.springframework.data.neo4j.repository.Neo4jRepository;
import org.springframework.data.repository.query.Param;

import java.util.List;

/**
 * @Description:
 * @Author:zhaops
 * @time: 2020/11/25 14:43
 */
public interface LisRepository extends Neo4jRepository<Lis,Long> {
    List<Lis> findByNameIs(String name);

    @Query("merge (n:实验室检查{name:{name}})  " +
            "on create set  " +
            "n.拼音编码={pycode}," +
            "n.静态知识标识={is_kl}," +
            "n.状态={status}," +
            "n.最大值={maxValue}," +
            "n.最小值={minValue}," +
            "n.范围={range}," +
            "n.单位={unit}, " +
            "n.实验室检查指标={indication} " +
            "on match set  " +
            "n.拼音编码={pycode}," +
            "n.静态知识标识={is_kl}," +
            "n.状态={status}," +
            "n.最大值={maxValue}," +
            "n.最小值={minValue}," +
            "n.范围={range}," +
            "n.单位={unit}, " +
            "n.实验室检查指标={indication} " +
            "RETURN n,[ (n)-[r]->(m) | [ r, m ] ], ID(n)\n")
    Lis createOrUpdate(@Param("name") String name,
                       @Param("is_kl") Integer is_kl,
                       @Param("pycode") String pycode,
                       @Param("status") Integer status,
                       @Param("maxValue") Double maxValue,
                       @Param("minValue") Double minValue,
                       @Param("range") Integer range,
                       @Param("unit") String unit,
                       @Param("indication") String indication);

    @Query("match (n:实验室检查) \n" +
            "where id(n) = :#{#entityInfo.id} \n" +
            "set  " +
            "n.name = :#{#entityInfo.name}," +
            "n.拼音编码 = :#{#entityInfo.pycode}," +
            "n.静态知识标识 = :#{#entityInfo.is_kl}," +
            "n.状态 = :#{#entityInfo.status}," +
            "n.单位 = {unit}" +
            "\n" +
            "RETURN n,[ (n)-[r]->(m) | [ r, m ] ], ID(n)\n")
    Lis update(@Param("entityInfo") EntityInfo entityInfo,
               @Param("unit") String unit);

    @Query("create (n:实验室检查) \n" +
            "set  " +
            "n.name = :#{#entityInfo.name}," +
            "n.拼音编码 = :#{#entityInfo.pycode}," +
            "n.静态知识标识 = :#{#entityInfo.is_kl}," +
            "n.状态 = :#{#entityInfo.status}," +
            "n.单位 = {unit}" +
            "\n" +
            "RETURN n,[ (n)-[r]->(m) | [ r, m ] ], ID(n)\n")
    Lis create(@Param("entityInfo") EntityInfo entityInfo,
               @Param("unit") String unit);

}
